# Demo_3
def count(f):
	def counted(*args):
		counted.call_count += 1
		return f(*args)
	counted.call_count = 0
	return counted
@count
def mul(x, y):
	return x * y


@count
def rfactorial(n):
	if n == 0:
		return 1
	else:
		return n * rfactorial(n-1)

def ifactorial(n):
	total = 1
	while n > 0:
		total = mul(total, n)
		n -= 1
	return total

# rfactorial(1000)
# ifactorial(1000)
# rfactorial.call_count
# mul.call_count
